<?php
/*
Plugin Name: Icelandic Post Name
Plugin URI: http://www.helgi.me/wordpress/icelandic-post-name/
Description: Lagf&aelig;rir heiti færslu með því að umbreyta <em>&thorn;</em>, <em>&eth;</em> og <em>&aelig;</em>.
Version: 0.1
Author: Helgi Hrafn Halldórsson
Author URI: http://www.helgi.me/
*/

function icelandic_post_name($post_name = '') {
	if ($post_name) return $post_name;

	$post_title = $_POST['post_title'];

	if (seems_utf8($post_title)) { // UTF-8
		$post_name = strtr( $post_title, array( chr(195).chr(144) => 'd', chr(195).chr(176) => 'd'));
		$post_name = str_replace( array( chr(195).chr(158), chr(195).chr(190)), 'th', $post_name);
		$post_name = str_replace( array( chr(195).chr(134), chr(195).chr(166)), 'ae', $post_name);
	} else {// ISO-8859-1
		$post_name = str_replace( array( chr(208), chr(240)), 'd', $post_title);
	}

	return $post_name;
}

add_filter('name_save_pre', 'icelandic_post_name', 0);
?>
